<?php 
require_once ( get_template_directory() . '/7league/init.php' );
 





function prepare_headlines($content)
	{
	$content=str_replace("<h1>","<h1><span>",$content);
	$content=str_replace("</h1>","</span></h1>",$content);
	
	$content=str_replace("<h2>","<h2><span>",$content);
	$content=str_replace("</h2>","</span></h2>",$content);

	$content=str_replace("<h3>","<h3><span>",$content);
	$content=str_replace("</h3>","</span></h3>",$content);

	return $content;
	}

// add_filter('the_content','prepare_headlines');




load_theme_textdomain('sevenleague',get_template_directory() . '/languages');



 // Setup Theme Functions
 
function my_theme_setup() {	
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' ); 
	if ( ! isset( $content_width ) ) $content_width = 980;		 
 
	// ADD FILTERS 
	add_filter( 'excerpt_length', 'the_excerpt_length' );
	add_filter( 'get_the_excerpt', 'custom_excerpt_more' ); 
	add_filter( 'excerpt_more', 'auto_excerpt_more' );

	// REGISTER THE MENU 
	register_nav_menus(
		array(
		  'main_menu_1' => 'The Main Menu' 
		)
	);
    } 
add_action('after_setup_theme', 'my_theme_setup');





 function the_excerpt_length( $length ) 
	{
	return 50;
	}


function continue_reading_link() 
	{
	return ' <a href="'. esc_url( get_permalink() ) . '"><span class="meta-nav">...</span></a>';
	}


function auto_excerpt_more( $more ) 
	{
	return continue_reading_link();
	}


function custom_excerpt_more( $output ) 
	{
	if ( has_excerpt() && ! is_attachment() ) 
		{
		$output .=  continue_reading_link();
		}
		return $output;
	}










/*
** THE COMMENTSTEMPLATE
*/
function mytheme_comment($comment, $args, $depth) 
	{
	$GLOBALS['comment'] = $comment; ?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
		<article id="comment-<?php comment_ID(); ?>" class="comment-body">
			<footer class="comment-author vcard">
				<?php echo get_avatar( $comment->comment_author_email, 60 ); ?>
				<p class='commentauthor'><?php  comment_author_link(); ?></p>
				<p class='comment-time'><?php comment_date(); ?>, <?php comment_time(); ?></p>							
			</footer>
			<div class="comments-body">				
				<?php comment_text() ?>
				<div class="reply">
					<?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?> | <?php edit_comment_link('Edit','  ','') ?>
 				</div>
				<?php if ($comment->comment_approved == '0') : ?>
					<em><?php _e('Your comment is awaiting moderation.','sevenleague'); ?></em>			
				<?php endif; ?>
			</div>
			<div class="clear"></div>
		</article>
	</li>
	<?php
   	}













class Menu_With_Description extends Walker_Nav_Menu 
	{
    	function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, &$output )
    		{
        		$id_field = $this->db_fields['id'];
        			if ( is_object( $args[0] ) ) 
				{
            				$args[0]->has_children = ! empty( $children_elements[$element->$id_field] );
				}
        		return parent::display_element( $element, $children_elements, $max_depth, $depth, $args, $output );
    		}
	function start_el(&$output, $item, $depth, $args ) 
		{
		global $wp_query;
		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
		$class_names = $value = '';
		$classes = empty( $item->classes ) ? array() : (array) $item->classes;
 		if( $args->has_children ) 
			{ 
			$classes[]="has-submenu"; 
			}
		$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item ) );
		$class_names = ' class="' . esc_attr( $class_names ) . '"';
		$output .= $indent . '<li id="menu-item-'. $item->ID . '"' . $value . $class_names .'>'; 
		$attributes = ! empty( $item->attr_title ) ? ' title="' . esc_attr( $item->attr_title ) .'"' : '';
		$attributes .= ! empty( $item->target ) ? ' target="' . esc_attr( $item->target ) .'"' : '';
		$attributes .= ! empty( $item->xfn ) ? ' rel="' . esc_attr( $item->xfn ) .'"' : '';
		$attributes .= ! empty( $item->url ) ? ' href="' . esc_attr( $item->url ) .'"' : '';
		if (trim($item->description)!="")
			{
			$attributes .= ! empty( $item->description) ? ' data-v="'.esc_Attr($item->description).'"' : '';
			}
		$item_output = $args->before;
		$item_output .= '<a'. $attributes .'>';
		$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after ;
		//$item_output .= '<b>' . $item->description . '</b>';
		//$item_output .= '<em></em>';
		if (trim($item->description)!="")
			{
			$item_output.='<span>'.$item->description.'</span>';
			}
		$item_output .= '</a>';
		$item_output .= $args->after;
		$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
	}
} 
 
 








 
/**
 * This file represents an example of the code that themes would use to register
 * the required plugins.
 *
 * It is expected that theme authors would copy and paste this code into their
 * functions.php file, and amend to suit.
 *
 * @package	   TGM-Plugin-Activation
 * @subpackage Example
 * @version	   2.3.6
 * @author	   Thomas Griffin <thomas@thomasgriffinmedia.com>
 * @author	   Gary Jones <gamajo@gamajo.com>
 * @copyright  Copyright (c) 2012, Thomas Griffin
 * @license	   http://opensource.org/licenses/gpl-2.0.php GPL v2 or later
 * @link       https://github.com/thomasgriffin/TGM-Plugin-Activation
 */


add_action( 'tgmpa_register', 'my_theme_register_required_plugins' );
function my_theme_register_required_plugins() {

	/**
	 * Array of plugin arrays. Required keys are name and slug.
	 * If the source is NOT from the .org repo, then source is also required.
	 */
	$plugins = array(
		array(
			'name' 			=> 'easyReservations',
			'slug' 			=> 'easyreservations',
			'source'			=> get_stylesheet_directory() . '/plugins/easyreservations.zip', // The plugin source
			'required' 		=> true,
			'force_activation' 		=> true, 
			'force_deactivation' 	=> false, 
		), 
	);

	// Change this to your theme text domain, used for internationalising strings
	$theme_text_domain = 'tgmpa';

	/**
	 * Array of configuration settings. Amend each line as needed.
	 * If you want the default strings to be available under your own theme domain,
	 * leave the strings uncommented.
	 * Some of the strings are added into a sprintf, so see the comments at the
	 * end of each line for what each argument will be.
	 */
	$config = array(
		'domain'       		=> $theme_text_domain,         	// Text domain - likely want to be the same as your theme.
		'default_path' 		=> '',                         	// Default absolute path to pre-packaged plugins
		'parent_menu_slug' 	=> 'themes.php', 				// Default parent menu slug
		'parent_url_slug' 	=> 'themes.php', 				// Default parent URL slug
		'menu'         		=> 'install-required-plugins', 	// Menu slug
		'has_notices'      	=> true,                       	// Show admin notices or not
		'is_automatic'    	=> false,					   	// Automatically activate plugins after installation or not
		'message' 			=> '',							// Message to output right before the plugins table
		'strings'      		=> array(
			'page_title'                       			=> __( 'Install Required Plugins', $theme_text_domain ),
			'menu_title'                       			=> __( 'Install Plugins', $theme_text_domain ),
			'installing'                       			=> __( 'Installing Plugin: %s', $theme_text_domain ), // %1$s = plugin name
			'oops'                             			=> __( 'Something went wrong with the plugin API.', $theme_text_domain ),
			'notice_can_install_required'     			=> _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.' ), // %1$s = plugin name(s)
			'notice_can_install_recommended'			=> _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends the following plugins: %1$s.' ), // %1$s = plugin name(s)
			'notice_cannot_install'  					=> _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s)
			'notice_can_activate_required'    			=> _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
			'notice_can_activate_recommended'			=> _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
			'notice_cannot_activate' 					=> _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s)
			'notice_ask_to_update' 						=> _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.' ), // %1$s = plugin name(s)
			'notice_cannot_update' 						=> _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s)
			'install_link' 					  			=> _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
			'activate_link' 				  			=> _n_noop( 'Activate installed plugin', 'Activate installed plugins' ),
			'return'                           			=> __( 'Return to Required Plugins Installer', $theme_text_domain ),
			'plugin_activated'                 			=> __( 'Plugin activated successfully.', $theme_text_domain ),
			'complete' 									=> __( 'All plugins installed and activated successfully. %s', $theme_text_domain ), // %1$s = dashboard link
			'nag_type'									=> 'updated' // Determines admin notice type - can only be 'updated' or 'error'
		)
	);

	tgmpa( $plugins, $config );

}


add_action( 'add_meta_boxes', 'add_rooms_metabox' );
function add_rooms_metabox()
	{
	add_meta_box( 'room_price_settings', 'Price settings', 'rooms_show_pricelink', 'easy-rooms','side','low' );
	}
function rooms_show_pricelink()
	{
	echo "<a href='admin.php?page=reservation-resources&room=".get_the_id()."' target='blank'>Edit prices</a>";
	}



function wr_wp_get_attachment( $attachment_id ) {

	$attachment = get_post( $attachment_id );
	return array(
		'alt' => get_post_meta( $attachment->ID, '_wp_attachment_image_alt', true ),
		'caption' => $attachment->post_excerpt,
		'description' => $attachment->post_content,
		'href' => get_permalink( $attachment->ID ),
		'src' => $attachment->guid,
		'title' => $attachment->post_title
	);
}







